#if !defined(BATTLEENC_H)
#define BATTLEENC_H

#if _MSC_VER > 1000
	#pragma once
#endif

#undef _WIN32_IE
#define _WIN32_IE 0x0501



#define APP_CLASS TEXT( "BATTLEENC" )

#ifdef _UNICODE
	#define APP_NAME L"BES - Battle Encoder Shirase 1.1 \x03B2" L"10"
#else
	#define APP_NAME TEXT( "BES - Battle Encoder Shirase 1.1 beta 10" )
#endif

#define APP_VERSION 110

#define APP_HOME_URL TEXT( "http://www.faireal.net/mion/" )

#ifdef _MBCS
	#undef _MBCS
#endif

#ifdef _UNICODE
	#ifndef UNICODE
		#define UNICODE
	#endif
	#define APP_COPYRIGHT L"Copyright \251 2004" L"\x2013" L"2006 mion"
#else
	#ifdef UNICODE
		#undef UNICODE
	#endif
	#define APP_COPYRIGHT "Copyright (c) 2004-2006 mion"
#endif

#include <windows.h>
#include <tchar.h>
#include <tlhelp32.h>
#include <shellapi.h>
#include <Windowsx.h> // DeleteFont MACRO
#include <commctrl.h> // TRACKBAR_CLASS
#include <stdio.h> // fputc
#include <stdlib.h> // abs
#include <shlwapi.h> // DLLVERSIONINFO
#include <math.h> // floor
#include <olectl.h> // Jpeg
#include <shlobj.h> // SHGetFolderPath

#include "resource.h"
#include "strings.utf8.h"
#include "sstp.sjis.h"

#define WATCHING_IDLE      ( (DWORD) -1 )
#define TARGET_PID_NOT_SET          ( 0UL )
#define TARGET_UNDEF ( TEXT( "<target not specified>" ) )

#define JUST_UPDATE_STATUS          ( 3U )


#define MAX_THREAD_CNT  128
#define MAX_PROCESS_CNT  256
#define MAX_WINDOWTEXT 1024
#define CP_SJIS 932U

#ifndef CP_UTF8
	#define CP_UTF8 65001U
#endif

#ifndef CREARTYPE_QUALITY
	#define CLEARTYPE_QUALITY 5
#endif

#define LANG_JAPANESEo ((WORD) -2)
#define LANG_CHINESE_T ((WORD) 2807 )
#define LANG_CHINESE_S ((WORD) 2803 )

#define IS_ENGLISH  ( GetLangauge() == LANG_ENGLISH )
#define IS_FINNISH  ( GetLanguage() == LANG_FINNISH )
#define IS_JAPANESE ( GetLanguage() == LANG_JAPANESE || GetLanguage() == LANG_JAPANESEo )
#define IS_JAPANESEo ( GetLanguage() == LANG_JAPANESEo )
#define IS_CHINESE   ( GetLanguage() == LANG_CHINESE_T || GetLanguage() == LANG_CHINESE_S )
#define IS_CHINESE_T ( GetLanguage() == LANG_CHINESE_T )
#define IS_CHINESE_S ( GetLanguage() == LANG_CHINESE_S )
#define IS_SPANISH   ( GetLanguage() == LANG_SPANISH )
#define IS_FRENCH   ( GetLanguage() == LANG_FRENCH )
#define REPEATED_KEYDOWN( lParam ) ( ( lParam ) & 0x40000000 )

#define IFF_SYSTEM                 -2
#define IFF_FRIEND                 -1
#define IFF_UNKNOWN                 0
#define IFF_FOE                     1
#define IFF_ENEMY                   1
#define IFF_ABS_FOE                 2

#define XLIST_WATCH_THIS           -1
#define XLIST_RESTART_0             0
#define XLIST_RESTART_1             1
#define XLIST_RESTART_2             2
#define XLIST_CANCELED           1024
#define XLIST_NEW_TARGET         2048
#define XLIST_UNFREEZE           4096

#define STOP_FROM_TRAY     0x000A
#define NORMAL_TERMINATION 0x1000
#define NOT_WATCHING       0x1001
#define THREAD_NOT_OPENED  0xEEEE
#define TARGET_MISSING     0xF000

#define WM_USER_HACK       ( WM_USER +   1 )
#define WM_USER_STOP       ( WM_USER +   2 )
#define WM_USER_RESTART    ( WM_USER +   3 )
#define WM_USER_NOTIFYICON ( WM_USER +  10 )
#define WM_USER_REFRESH    ( WM_USER +  20 )

#define WM_USER_BUTTON     ( WM_USER +  30 )

typedef struct {
	WORD wIndex;
	TCHAR szTitle[ MAX_PROCESS_CNT ][ MAX_WINDOWTEXT ];
	DWORD dwThreadId[ MAX_PROCESS_CNT ];
	HWND hwnd[ MAX_PROCESS_CNT ];
} WININFO, *LPWININFO;

typedef struct {
	TCHAR szExe[ MAX_PATH * 2 ];
	TCHAR szPath[ MAX_PATH * 2 ];
	TCHAR szText[ MAX_WINDOWTEXT ];
	DWORD dwProcessId;
	DWORD dwThreadId[ MAX_THREAD_CNT ];
	WORD wThreadCount;
	int iIFF;
	int bWatch;
} TARGETINFO, *LPTARGETINFO;

typedef struct {
	HWND myHwnd;
	int iMyId;
	LPTARGETINFO lpTarget;
	LPTSTR lpszStatus[ 16 ];

} HACK_PARAMS, *LPHACK_PARAMS;

DWORD WINAPI Hack( LPVOID dwTargetProcessId );

BOOL SetTargetPlus( const HWND hWnd, HANDLE * phChildThread, LPHACK_PARAMS lphp );
BOOL SetTargetPlus( const HWND hWnd, HANDLE * phChildThread, LPHACK_PARAMS lphp, LPCTSTR lpszTargetPath, LPCTSTR lpszTargetExe );

BOOL Unfreeze( HWND hWnd, LPTARGETINFO lpTarget );

VOID CALLBACK DummyCallback( HWND hWnd, UINT uMsg, DWORD dwData, LRESULT lResult );

LRESULT CALLBACK xList(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK Question( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );

int UpdateProcessSnap( LPTARGETINFO target, UINT uMaxTargets );

DWORD PathToProcess( LPCTSTR lpszPath );

BOOL PathToExe( LPCTSTR lpszPath, LPTSTR lpszExe, const int iBufferSize );
BOOL PathToExe( LPTSTR lpszPath );
BOOL PathToExeEx( LPTSTR lpszPath, int iBufferSize );

BOOL GetProcessInfoMsg( LPTARGETINFO lpTarget, LPTSTR msg, int iBufferSize );
BOOL IsActive( VOID );

BOOL OpenDebugLog();
BOOL PrintFileHeader( FILE * fp );
BOOL WriteDebugLog( LPCTSTR str );
BOOL CloseDebugLog();

BOOL GetIniPath( LPTSTR lpszPath );
BOOL ReadIni( VOID );
WORD SetLanguage( const WORD wLID );
WORD GetLanguage( VOID );
BOOL CheckLanguageMenuRadio( const HWND hWnd );
VOID InitMenuEng( const HWND hWnd );
VOID InitToolTipsEng( TCHAR str[ 4 ][ 256 ] );

#ifdef _UNICODE
VOID InitMenuFin( const HWND hWnd );
VOID InitToolTipsFin( WCHAR str[ 4 ][ 256 ] );
VOID InitMenuJpn( const HWND hWnd );
VOID InitToolTipsJpn( WCHAR str[ 4 ][ 256 ] );
VOID InitMenuSpa( const HWND hWnd );
VOID InitToolTipsSpa( WCHAR str[ 4 ][ 256 ] );

VOID InitToolTipsChiT( WCHAR str[ 4 ][ 256 ] );
VOID InitToolTipsChiS( WCHAR str[ 4 ][ 256 ] );
VOID InitMenuChiT( const HWND hWnd );
VOID InitMenuChiS( const HWND hWnd );



VOID InitToolTipsFre( WCHAR str[ 4 ][ 256 ] );
VOID InitMenuFre( const HWND hWnd );
#endif


BOOL WriteIni( VOID );
BOOL EnableLoggingIni( BOOL bEnabled );
BOOL SetSliderIni( LPCTSTR lpszTarget, const int iSlider );
int GetSliderIni( LPCTSTR lpszTarget );
VOID SetWindowPosIni( const HWND hWnd );
VOID GetWindowPosIni( LPPOINT lppt );
BOOL IsAbsFoe( LPCTSTR lpExe, LPCTSTR lpPath );
BOOL IsAbsFoe( LPCTSTR lpPath );


VOID InitSWIni( VOID );
VOID SaveCmdShow( HWND hWnd, int nCmdShow );
int GetCmdShow( HWND hWnd );

VOID ShowProcessWindow( HWND hCurWnd, LPTARGETINFO lpTarget, int iShow );
VOID BES_ShowWindow( HWND hCurWnd, HWND hwnd, int iShow );
#define BES_ERROR                -600

#define BES_DELETE_KEY           -100
#define BES_HIDE                    0
#define BES_SHOW                    1
#define BES_SHOW_MANUALLY           2

VOID GetTargetTitleIni( LPTSTR lpStr, int iMax );
VOID GShow( HWND hWnd );


HFONT MyCreateFont( const HDC hDC, LPCTSTR lpszFace, int iPoint, BOOL bBold, BOOL bItalic );
HFONT MyCreateFont( LPCTSTR lpszFace, int iPoint, BOOL bBold, BOOL bItalic );
HFONT GetFontForURL( HDC hdc );
HFONT UpdateFont( HFONT hFont );

int MainWindowUrlHit( LPARAM lParam );
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK xList(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK Settings( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );

VOID AboutShortcuts( HWND hWnd );


BOOL CALLBACK WndEnumProc( HWND hwnd, LPARAM lpwi );
int ListProcessThreads( DWORD dwOwnerPID, DWORD *dwThreadIdTable );
VOID GetProcessDetails( DWORD dwProcessId, LPTARGETINFO lpTargetInfo );


BOOL SaveSnap( const HWND hWnd );
int SaveSnap( LPCTSTR lpszSavePath );

VOID AdjustLength( LPTSTR lptstr );


BOOL SetSliderText( HWND hDlg, int iControlId, LONG lPercentage );
BOOL SliderMoved( WPARAM wParam );
BYTE GetSliderParam( LONG lSlider );

int GetArgument( LPCTSTR lpszCmdLine, int iBufferSize, LPTSTR lpszMyPath, LPTSTR lpszTargetPath, LPTSTR lpszTargetExe );


VOID SetRealTimeMode( const HWND hWnd, const BOOL bRealTime, const HANDLE * phChildThread, LPTSTR lpszWindowText );

BOOL IsWindowsXPOrLater();
VOID Exit_CommandFromTaskbar( const HWND hWnd );
int GetShell32Version( VOID );
int InitNotifyIconData( HWND hWnd, NOTIFYICONDATA * lpni, TARGETINFO * ti );

VOID UpdateStatus( const HWND hWnd );
HWND CreateTooltip ( const HINSTANCE hInst, const HWND hwndBase, LPCTSTR str );
VOID UpdateTooltip( const HINSTANCE hInst, const HWND hwndBase, LPCTSTR str, const HWND hwndToolTip );


VOID Unwatch( HANDLE hSema, HANDLE hThread, BOOL * lpbWatch );







int OpenBrowser( LPCTSTR lpUrl );

int SSTP_Aviutl( HWND hWnd, LPCTSTR lpTitle );

BOOL DirectSSTP( HWND hWnd, char * hcScript );
BOOL DirectSSTP( HWND hWnd, char * hcSakura, char * hcKero );
BOOL DirectSSTP( HWND hWnd, char * hcSakura, char * hcKero, char * hcCharset );
VOID DirectSSTP( LPCTSTR str );


#endif // !defined(BATTLEENC_H)


#define BTN_X1     480
#define BTN_WIDTH  130
#define BTN_X2 ( BTN_X1 + BTN_WIDTH )

#define BTN_HEIGHT_LARGE  75
#define BTN_HEIGHT_SMALL  50

#define BTN0_Y1  30
#define BTN0_Y2 ( BTN0_Y1 + BTN_HEIGHT_LARGE )
#define BTN1_Y1 125
#define BTN1_Y2 ( BTN1_Y1 + BTN_HEIGHT_SMALL )
#define BTN2_Y1 195
#define BTN2_Y2 ( BTN2_Y1 + BTN_HEIGHT_LARGE )
#define BTN3_Y1 330
#define BTN3_Y2 ( BTN3_Y1 + BTN_HEIGHT_SMALL )



int GetButtonId( POINT pt );


#ifndef HIMETRIC_INCH
	#define HIMETRIC_INCH 2540
#endif

HFONT MyCreateFont( const HDC hDC, LPCTSTR lpszFace, int iPoint, BOOL bBold, BOOL bItalic );
HFONT MyCreateFont( LPCTSTR lpszFace, int iSize, BOOL bBold, BOOL bItalic );

#define IGNORE_ARGV 200