#include "BattleEnc.h"

#define BES_TRAY_MENU( x ) (\
	IDM_STOP_FROM_TRAY - IDM_MENU_BASE ==  ( x ) ||\
	IDM_SHOWWINDOW     - IDM_MENU_BASE ==  ( x ) ||\
	IDM_EXIT_FROM_TRAY - IDM_MENU_BASE ==  ( x ) )


HWND CreateTooltip( const HINSTANCE hInst, const HWND hwndBase, LPCTSTR str )
{
	INITCOMMONCONTROLSEX iccex; 
	iccex.dwICC = ICC_WIN95_CLASSES;
	iccex.dwSize = sizeof( INITCOMMONCONTROLSEX );
	InitCommonControlsEx( &iccex );

	HWND hwndToolTip = CreateWindowEx(
		WS_EX_TOPMOST,
		TOOLTIPS_CLASS,
		NULL,
		WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		hwndBase,
		NULL,
		hInst,
		NULL
	);

	SetWindowPos(
		hwndToolTip,
		HWND_TOPMOST,
		0,
		0,
		0,
		0,
		SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE
	);

	TCHAR lpszText[ 256 ];
	lstrcpy( lpszText, str );
	RECT rectClient;
	GetClientRect ( hwndBase, &rectClient );
	TOOLINFO ti;
	ZeroMemory( &ti, sizeof( TOOLINFO ) );
	ti.cbSize = sizeof( TOOLINFO );
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hwndBase;
	ti.hinst = hInst;
	ti.uId = 0U;
	ti.lpszText = lpszText;
	ti.rect = rectClient;

	SendMessage( hwndToolTip, TTM_ADDTOOL, 0U, (LPARAM) &ti );

	return hwndToolTip;
}

VOID UpdateTooltip( const HINSTANCE hInst, const HWND hwndBase, LPCTSTR str, const HWND hwndToolTip )
{
	TCHAR lpszText[ 256 ];
	lstrcpy( lpszText, str );
	TOOLINFO ti;
	ZeroMemory( &ti, sizeof( TOOLINFO ) );
	ti.cbSize = sizeof( TOOLINFO );
	ti.hwnd = hwndBase;
	ti.hinst = hInst;
	ti.uId = 0U;
	ti.lpszText = lpszText;
	SendMessage( hwndToolTip, TTM_UPDATETIPTEXT, 0U, (LPARAM) &ti );
}

#ifdef _UNICODE
VOID InitToolTipsFin( WCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FIN0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FIN1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FIN2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FIN3, -1, str[ 3 ], 255 );
}

VOID InitToolTipsSpa( WCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_SPA0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_SPA1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_SPA2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_SPA3, -1, str[ 3 ], 255 );
}

VOID InitToolTipsChiT( WCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI0T, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI1T, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI2T, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI3T, -1, str[ 3 ], 255 );
}

VOID InitToolTipsChiS( WCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI0S, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI1S, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI2S, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_CHI3S, -1, str[ 3 ], 255 );
}

VOID InitToolTipsJpn( WCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_JPN0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_JPN1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_JPN2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_JPN3, -1, str[ 3 ], 255 );
}

VOID InitToolTipsFre( TCHAR str[ 4 ][ 256 ] )
{
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FRE0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FRE1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FRE2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_TOOLTIP_FRE3, -1, str[ 3 ], 255 );
}


VOID InitMenuFin( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;
	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FIN0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FIN1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FIN2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FIN3, -1, str[ 3 ], 255 );

	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_21, -1, str[ 21 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FIN_30, -1, str[ 30 ], 255 );
	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}

VOID InitMenuSpa( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;
	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_SPA0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_SPA1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_SPA2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_SPA3, -1, str[ 3 ], 255 );

	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_21, -1, str[ 21 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, SPA_30, -1, str[ 30 ], 255 );
	
	
	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29 ] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}





VOID InitMenuFre( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;
	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FRE0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FRE1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FRE2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_FRE3, -1, str[ 3 ], 255 );

	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_21, -1, str[ 21 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_28, -1, str[ 28 ], 255 );
	
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, FRE_30, -1, str[ 30 ], 255 );
	
	
	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29 ] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}




VOID InitMenuJpn( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	
	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_JPN0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_JPN1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_JPN2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_JPN3, -1, str[ 3 ], 255 );
	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}


	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_21, -1, str[ 21 ], 255 );

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, JPN_30, -1, str[ 30 ], 255 );

	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 
		4U,
		MF_BYPOSITION | MF_POPUP | MF_ENABLED | MF_STRING,
		(UINT) GetSubMenu( hSubMenu, 4 ),
		str[ 29 ]
	);
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );

	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}

VOID InitMenuChiT( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;
	
	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI0T, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI1T, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI2T, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI3T, -1, str[ 3 ], 255 );

	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_20, -1, str[ 20 ], 255 );
	
//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_21, -1, str[ 21 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHT_30, -1, str[ 30 ], 255 );

	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29 ] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}

VOID InitMenuChiS( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;
	
	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ];
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI0S, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI1S, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI2S, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, S_MENU_CHI3S, -1, str[ 3 ], 255 );

	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );

	}

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_21, -1, str[ 21 ], 255 );

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, CHS_30, -1, str[ 30 ], 255 );

	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29 ] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
	
	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}

#endif

VOID InitToolTipsEng( TCHAR strToolTips[ 4 ][ 256 ] )
{
	lstrcpy( strToolTips[ 0 ], TEXT( "Select the target process" ) );
	lstrcpy( strToolTips[ 1 ], TEXT( "Stop limiting and/or watching totally" ) );
	lstrcpy( strToolTips[ 2 ], TEXT( "Control how much to limit the process" ) );
	lstrcpy( strToolTips[ 3 ], TEXT( "End the program" ) );
}



VOID InitMenuEng( const HWND hWnd )
{
	HMENU hMenu = GetMenu( hWnd );

	UINT flagRealtime = ( ( GetMenuState( hMenu, IDM_REALTIME, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	UINT flagLogging = ( ( GetMenuState( hMenu, IDM_LOGGING, MF_BYCOMMAND ) ) & MFS_CHECKED ) ? MFS_CHECKED : MFS_UNCHECKED ;

	TCHAR str[ 50 ][ 256 ] = {
		TEXT( "&File" ),
		TEXT( "&Do" ),
		TEXT( "&Options" ),
		TEXT( "&Help" )
	};
	for( UINT u = 0U; u < 4U; u++ )
	{
		ModifyMenu( hMenu, u, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hMenu, (int) u ), str[ u ] );
	}
#ifdef _UNICODE
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_0, -1, str[ 0 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_1, -1, str[ 1 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_2, -1, str[ 2 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_3, -1, str[ 3 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_4, -1, str[ 4 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_5, -1, str[ 5 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_6, -1, str[ 6 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_7, -1, str[ 7 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_8, -1, str[ 8 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_9, -1, str[ 9 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_10, -1, str[ 10 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_11, -1, str[ 11 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_12, -1, str[ 12 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_13, -1, str[ 13 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_14, -1, str[ 14 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_15, -1, str[ 15 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_16, -1, str[ 16 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_17, -1, str[ 17 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_18, -1, str[ 18 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_19, -1, str[ 19 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_20, -1, str[ 20 ], 255 );
	//
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_21, -1, str[ 21 ], 255 );

	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_22, -1, str[ 22 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_23, -1, str[ 23 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_24, -1, str[ 24 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_25, -1, str[ 25 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_26, -1, str[ 26 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_27, -1, str[ 27 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_28, -1, str[ 28 ], 255 );
	for( int i = 0; i <= 28; i++ )
	{
		if( BES_TRAY_MENU( i ) ) continue;
		UINT uMenuId = (UINT) ( IDM_MENU_BASE  +  i );
		ModifyMenu( hMenu, uMenuId, MF_BYCOMMAND, uMenuId, str[ i ] );
	}
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_29, -1, str[ 29 ], 255 );
	MultiByteToWideChar( CP_UTF8, 0 /*MB_ERR_INVALID_CHARS*/, ENG_30, -1, str[ 30 ], 255 );

	
	HMENU hSubMenu;
	hSubMenu = GetSubMenu( hMenu, 2 );
	ModifyMenu( hSubMenu, 4U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 4 ), str[ 29 ] );
	hSubMenu = GetSubMenu( hMenu, 3 );
	ModifyMenu( hSubMenu, 6U, MF_BYPOSITION | MF_POPUP, (UINT) GetSubMenu( hSubMenu, 6 ), str[ 30 ] );
#endif


	DrawMenuBar( hWnd );
	UpdateStatus( hWnd );
	CheckMenuItem( hMenu, IDM_REALTIME, MF_BYCOMMAND | flagRealtime );
	CheckMenuItem( hMenu, IDM_LOGGING, MF_BYCOMMAND | flagLogging );
}
